@implements IDisposable
@inject Observatory obz

<div style="width: @getTimerWidth(); height: 20px; box-shadow: inset 0 20px 20px -20px @getTimerCol(); display: @getTimerDisp(); transition: width 1s, box-shadow 5s; transition-timing-function: linear;"></div>

@code {

    private readonly static int INTERVAL_MS = 1000;

    private long duration;
    private long startTime;
    private long endTime;
    private bool looping = false;

    protected override void OnInitialized(){
        obz.Register<int>("startTimer", onTimerStart, "TimerComponent");
        obz.Register<bool>("stopTimer", onTimerStop, "TimerComponent");
    }

    private void onTimerStart(int totalSeconds){
        startTime = currentTime();
        duration = totalSeconds*1000;
        endTime = startTime + duration;
        looping = true;
        Task _ = loop();
    }

    private void onTimerStop(bool ignored){
        looping = false;
        base.StateHasChanged();
    }

    private static long currentTime(){
        return DateTimeOffset.UtcNow.ToUnixTimeMilliseconds();
    }

    private async Task loop(){
        while(looping && currentTime() < endTime){
            base.StateHasChanged();
            await Task.Delay(INTERVAL_MS);
        }
        if (looping){
            looping = false;
            base.StateHasChanged(); // hide timer
        }
    }

    private float getPercLeft(){
        return (endTime-currentTime())/(float) duration;
    }

    private string getTimerCol(){
        var percLeft = getPercLeft();
        if (percLeft < .1)
            return "darkred";
        else if (percLeft < .2)
            return "red";
        else if (percLeft < .4)
            return "darkorange";
        else if (percLeft < .6)
            return "orange";
        else if (percLeft < .8)
            return "green";
        else
            return "darkgreen";
    }

    private string getTimerWidth(){
        return $"{getPercLeft()*100}%";
    }

    private string getTimerDisp(){
        return looping ? "block" : "none";
    }

    public void Dispose(){
        this.looping = false;
        obz.Deregister("TimerComponent");
    }

}